#!/bin/sh
#
# This script starts DNA under the Tcl interpreter,
# reading commands from a special .wishrc script which
# launches DNA and retains the Tcl interactive interpreter.
#

loclibdir=${DNA_LIB_DIR:=.}
export DNA_LIB_DIR
DNA_WISH=/usr/bin/wish
export DNA_WISH

TKCON=true
for i in $@ ; do
   case $i in
      -noc*)
	   TKCON=;;
      --help)
	   echo "Standard usage:"
	   echo "   dna"
	   exit 0
	   ;;
      --version)
	   echo "DNA version 3"
	   exit 0
	   ;;
   esac
done

if [ $TKCON ]; then

   exec ${loclibdir}/tkcon.tcl \
	-eval "source ${loclibdir}/console.tcl" \
        -slave "package require Tk; set argc $#; set argv [list $*]; \
        source ${loclibdir}/dna.tcl"
else

#
# Run the stand-in for wish (dnaexec), which acts exactly like "wish"
# except that it replaces ~/.wishrc with dna.tcl.  This executable is
# *only* needed when running without the console; the console itself is
# capable of sourcing the startup script.
#
   exec ${loclibdir}/dnaexec -- $@

fi
