# Tcl startup script for dna
namespace path {::tcl::mathop ::tcl::mathfunc}

load ./dna.so

toplevel .dna
simple .dna.drawing -width 800 -height 800
pack .dna.drawing -expand true -fill both

set drawwindow .dna.drawing

wm withdraw .

# set rate 20
set rate 1

proc multistep {} {
   global rate
   for {set i 0} {$i < $rate} {incr i} {
      step
   }
   redraw
}

proc simulate {} {
   global rate
   multistep
   if {$rate != 0} {
      after 1 simulate
   }
}

proc rate {r} {
   global rate
   set rate $r
}

proc save {f} {
   set fd [open $f w]
   puts $fd "# DNA state file"
   puts $fd ""

   set types [type]
   foreach t $types {
      set values [type $t]
      puts $fd "type $t $values"
   }
   puts $fd ""

   set rulesets [rule]
   foreach s $rulesets {
      set ruletypes [rule list $s]
      foreach t $ruletypes {
	 set conds [rule list $s $t]
	 puts $fd "rule add $s $t [list $conds]"
      }
   }
   puts $fd ""
   puts $fd "# Current state"
   puts $fd ""

   set cells [cell]
   foreach c $cells {
      set values [cell $c]
      set cargs [join [list cell $c $values]]
      puts $fd $cargs
   }
   puts $fd ""

   puts $fd ""
   puts $fd "# Pending change events"
   puts $fd ""

   set cells [pending]
   foreach c $cells {
      set values [pending $c]
      set cargs [join [list cell $c $values]]
      puts $fd $cargs
   }
   close $fd
}

start
# Don't run in real time for now; require step command
# simulate
