# dnastore3.tcl
# Snowflakes!
#
# Declare -1 types.  Only type "space" is transparent.
# Use up the primary colors.  Type name is the color
# name, for no particular reason.  Values are real,
# from 0 to 1.

init

type space     0   0   0   0
type black     0   0   0   1
type red       1   0   0   1
type green     0   1   0   1
type blue      0   0   1   1
type yellow    1   1   0   1
type cyan      0   1   1   1
type magenta   1   0   1   1
type white     1   1   1   1

# Only one simple ruleset declared for demonstration
# purposes.

rule add test space \
  {red   {red > 1 red < 4 blue = 0} \
   green {green > 1 green < 4} \
   blue  {blue > 1 blue < 4 red = 0}}
rule add test red \
  {space {red > 3} \
   space {red < 2} \
   space {blue > 0}}
rule add test green \
  {space {green > 3} \
   space {green < 2}}
rule add test blue \
  {space {blue > 3} \
   space {blue < 2} \
   space {red > 0}}

# Draw one ring of blue


cell  1 -2  0  blue test
cell -1 -2  0  blue test
cell -2  0  0  blue test
cell -1  2  0  blue test
cell  1  2  0  blue test
cell  2  0  0  blue test

# Setup to draw through z=00 only 
step
zplane on
zplane 0
zoom 8
redraw

# Let's have some fun. . .
for {set i 0; set j 0} {$i <= 720} {incr i; incr j} {
   view $i 0 1 1
   redraw
   if {$j == 20} {step; set j 0}
}
